
import java.util.Vector;
import java.io.*;

class DirFailedException extends Exception
	{
	DirFailedException(String exception)
		{
		System.out.println("dir command failed with exception: " + exception);
		}
	}

public class DirCommand
	{
	public static void main(String[] arguments)
		{
		try
			{
			String dirArg = "";
			if (arguments.length > 0)
				dirArg = arguments[0];

			String[] dirOutput = dir(dirArg);
			//System.out.println("dir output follows");
			for (int i = 0; i < dirOutput.length; i++)
				System.out.println(dirOutput[i]);
			}
		catch (DirFailedException e)
			{System.out.println("dir command failed: " + e);}
		}

	public static String[] dir(String directory) throws DirFailedException
		{
		/*
		Execute a dir command and return its output as a string array.
		Throws DirFailedException if the command failed.
		*/

		try
			{
			//set up the command
			String[] commandArray = {"cmd.exe /c dir ", directory};

			//execute it
			Process child = Runtime.getRuntime().exec(commandArray);

			//get its output
			DataInputStream in = new DataInputStream(child.getInputStream());
			Vector commandOutput = new Vector();
			String line;
			while ((line = in.readLine()) != null)
				commandOutput.addElement(line);

			//did it fail?
			if (child.waitFor() != 0)
				throw new DirFailedException("" + child.exitValue());

			//okay, command succeeded, return its output
			String[] returnValue = new String[commandOutput.size()];
			commandOutput.copyInto(returnValue);
			return returnValue;
			}
		catch (DirFailedException e) { throw e; }
		catch (Exception e) { throw new DirFailedException(e.toString()); }
		}
	}

