import java.util.Vector;
import java.util.Random;
import java.awt.*;
import java.awt.image.*;

//created packages
import trees.OrderedTree;
import compare.Comparable;

class Record implements Comparable
	{
	/*
	This class generalizes the key values to be inserted into
	binary search trees and other data structures.
	*/

	private String value;

	public Record(String value)
		{
		this.value = value;
		}

	public int compareTo(Comparable other)
		{
		return ((this.value).compareTo(((Record) other).value));
		}

	public String toString()
		{
		return value;
		}
	}

public class OrderedTreeTest extends java.applet.Applet
	{
	OrderedTree t0 = new OrderedTree();
	Image treeImage;
	Graphics treeImageGraphics;
	int displayWidth = 800;
	int displayHeight = 800;
	int imageWidth = 0;
	int imageHeight = 0;

	public boolean handleEvent(Event event)
		{
		if (event.id == Event.WINDOW_DESTROY)
			System.exit(0);
		return super.handleEvent(event);
		}

	public void init()
		{
		this.resize(displayWidth, displayHeight);

		//create an image
		treeImage = this.createImage(displayWidth, displayHeight);
		treeImageGraphics = treeImage.getGraphics();
		treeImageGraphics.setColor(this.getBackground());
		treeImageGraphics.fillRect(0, 0, displayWidth, displayHeight);

		String[][] s = {
						{"a"},

						{"a", "b"},
						{"a", "c"},
						{"a", "d"},

						{"a", "b", "e"},
						{"a", "b", "f"},

						{"a", "c", "g"},

						{"a", "d", "w"},
						{"a", "d", "x"},
						{"a", "d", "y"},
						{"a", "d", "z"},

						{"a", "b", "f", "h"},
						};

		Record[][] foo = new Record[20][];
		for (int i = 0; i < s.length; i++)
			{
			foo[i] = new Record[s[i].length];
			for (int j = 0; j < s[i].length; j++)
				foo[i][j] = new Record(s[i][j]);
			}

		OrderedTree t0 = new OrderedTree();
		for (int i = 0; i < s.length; i++)
			t0.insert(foo[i]);

		t0.display(treeImageGraphics);
		repaint();
		}

	public void paint(Graphics g)
		{
		g.drawImage(treeImage, 0, 0, this);
		}


/*
	public static void main(String[] arguments)
		{
		OrderedTreeTest f = new OrderedTreeTest();
		//f.resize(displayWidth, displayHeight);
		f.resize(800, 800);
		f.show();
		}

	public boolean imageUpdate(Image image, int infoFlags,
								int x, int y, int width, int height)
		{
		//if image is complete, get its dimensions
		if ((infoFlags & ImageObserver.ALLBITS) != 0)
			{
			imageWidth = image.getWidth(null);
			imageHeight = image.getHeight(null);
			repaint();
			return false;
			}
		else
			return true;
		}

	public void update(Graphics g)
		{
		paint(g);
		}

	public void paint(Graphics g)
		{
		//create an image
		treeImage = createImage(displayWidth, displayHeight);
		treeImageGraphics = treeImage.getGraphics();
		treeImageGraphics.setColor(getBackground());
		treeImageGraphics.fillRect(0, 0, displayWidth, displayHeight);

		int num = 5;
		Random r = new Random();
		for (int i = 0; i < num; i++)
			{
			Record rec = new Record(10 + (int) (r.nextFloat()*num));
			t0.insert(rec);
			}
		t0.display(treeImageGraphics);

		g.drawImage(treeImage, 0, 0, this);
		}

*/
	}

